'ui';
importClass(com.stardust.autojs.core.accessibility.AccessibilityBridge.WindowFilter);
let bridge = runtime.accessibilityBridge;
let bridgeField = runtime.getClass().getDeclaredField("accessibilityBridge");
let configField = bridgeField.getType().getDeclaredField("mConfig");
configField.setAccessible(true);
configField.set(bridge, configField.getType().newInstance());
bridge.setWindowFilter(new JavaAdapter(AccessibilityBridge$WindowFilter, {
    filter: function (info) {
        return true;
    }
}));
ui.layout(
    <vertical h='*' w='*'>
        <appbar id='appbar' >
            <toolbar id="toolbar" title="多闪刷视频" />
        </appbar>
        <frame h="*" w="*">
            <vertical h="*" w="*">
                <horizontal padding="10 8" h="auto" w="*">
                    <Switch id="autoService" text="无障碍服务" checked="{{auto.service != null}}" padding="8 8 8 8" textSize="16sp" textColor='#000000' />
                    <Switch id="autoPermission" text="悬浮窗权限" checked="{{!!$floaty.checkPermission()}}" padding="8 8 8 8" textSize="16sp" textColor='#000000' />
                </horizontal>
                <View h="1" w="*" />
                <card margin="3 3" cardElevation="0" cardCornerRadius="10" cardBackgroundColor="#AFEEEE">
                <vertical padding="3 1 1 1" h="auto">
                    <text gravity='left' text="软件说明" textColor="#009688" textSize="13sp" maxLines="1" />
                    <text gravity='left' text="1. 作者_葫芦侠三楼.【Rain】茶坊" textColor="#222222" textSize="13sp" maxLines="1" />
                    <text gravity='left' text="2. 本软件基于Auto.js编写手写,仅用于交流学习" textColor="#222222" textSize="13sp" maxLines="1" />
                    <text gravity='left' text="3. 如需反馈和交流，可点击最右上角↗加入反馈QQ群" textColor="#222222" textSize="13sp" maxLines="1" />
                </vertical>
            </card>
                <card w="*" h="auto" margin="10 5" cardCornerRadius="10dp" cardBackgroundColor="#fffffb" padding="15 10">
                    <vertical gravity="center|left" w="*">
                        <horizontal gravity='left|center'>
                            <text marginLeft="10" textSize="13sp" textColor="#000000">点赞功能：</text>
                            <checkbox id="点赞" text="开启" />
                            <horizontal id='点赞率_布局' visibility='invisible'>
                                <text marginLeft="5" textSize="15sp" textColor="#000000">点赞率：</text>
                                <input id="点赞率" singleLine="true" textSize="15sp" textColor="#7a1723" w='38' text='10' hint=''> </input>
                                <text marginLeft="1" textSize="15sp" textColor="#000000">%</text>
                            </horizontal>
                        </horizontal>

                        <horizontal gravity='left|center'>
                            <text marginLeft="10" textSize="13sp" textColor="#000000">关注功能：</text>
                            <checkbox id="关注" text="开启" />
                            <horizontal id='关注率_布局' visibility='invisible'>
                                <text marginLeft="5" textSize="15sp" textColor="#000000">关注率：</text>
                                <input id="关注率" singleLine="true" textSize="15sp" textColor="#7a1723" w='38' text='10' hint=''> </input>
                                <text marginLeft="1" textSize="15sp" textColor="#000000">%</text>
                            </horizontal>
                        </horizontal>
{/* 
                        <horizontal gravity='left|center'>
                            <text marginLeft="10" textSize="13sp" textColor="#000000">收藏功能：</text>
                            <checkbox id="收藏" text="开启" />
                            <horizontal id='收藏率_布局' visibility='invisible'>
                                <text marginLeft="5" textSize="15sp" textColor="#000000">收藏率：</text>
                                <input id="收藏率" singleLine="true" textSize="15sp" textColor="#7a1723" w='38' text='10' hint=''> </input>
                                <text marginLeft="1" textSize="15sp" textColor="#000000">%</text>
                            </horizontal>
                        </horizontal> */}

                        <horizontal gravity='left|center'>
                            <text marginLeft="10" textSize="13sp" textColor="#000000">视频时长：</text>
                            <input gravity='center' id="视频时长_min" singleLine="true" textSize="15sp" textColor="#7a1723" w='38' text='5' hint=''> </input>
                            <text marginLeft="1" textSize="15sp" textColor="#000000">-</text>
                            <input gravity='center' id="视频时长_max" singleLine="true" textSize="15sp" textColor="#7a1723" w='38' text='8' hint=''> </input>
                            <text marginLeft="1" textSize="15sp" textColor="#000000">秒</text>
                        </horizontal>

                        <horizontal>
                            <text marginTop="2" marginLeft="10" textSize="15sp" textColor="#000000">运行数量：</text>
                            <input id="运行数量_视频" singleLine="true" marginTop="2" textSize="15sp" textColor="#7a1723" w='80' text='10'> </input>
                            <text marginTop="2" marginLeft="2" textSize="15sp" textColor="#000000">个</text>
                        </horizontal>
                    </vertical>
                </card>
              
            </vertical>

            {/*底部控件  */}
            <vertical id="foot" h="*" w="*" gravity="center|bottom" >
                <card id="start" w="*" h="auto"  cardCornerRadius="5dp" gravity="center" cardBackgroundColor="#007d65">
                    <text bg="#007d65" textColor="#fffffb" gravity='center' text="启动悬浮窗" w="*" padding="10" />
                </card>
            </vertical>
        </frame>
    </vertical>
);
ui.autoService.on("check", function (checked) {
    if (checked && auto.service == null) {
        app.startActivity({
            action: "android.settings.ACCESSIBILITY_SETTINGS"
        });
    }
    if (!checked && auto.service != null) {
        auto.service.disableSelf();
    }
});

ui.autoPermission.on("check", function (checked) {
    if (checked && !$floaty.checkPermission()) {
        floaty.requestPermission()
        ui.autoPermission.attr('checked', 'false')
    }
});

//创建选项菜单(右上角)
activity.setSupportActionBar(ui.toolbar);
ui.emitter.on("create_options_menu", menu => {
    menu.add('加入QQ群');
 
    menu.add("查看日志");
});
//监听选项菜单点击
ui.emitter.on("options_item_selected", (e, item) => {
    switch (item.getTitle()) {
        case "查看日志":
            app.startActivity("console");
            break;
      
        case "加入QQ群":
            app.startActivity({
                data: "mqqapi://card/show_pslcard?card_type=group&uin=" + '736363375'
            })
            break;
    }
    e.consumed = true;
});
ui.emitter.on('restart', () => {
    ui.autoService.attr('checked', !!auto.service)
    ui.autoPermission.attr('checked', !!$floaty.checkPermission())
})
//  多选框显示
ui.点赞.on('check', (result) => {
    if (result) ui.点赞率_布局.attr('visibility', 'visible')
    if (!result) ui.点赞率_布局.attr('visibility', 'invisible')
})
ui.关注.on('check', (result) => {
    if (result) ui.关注率_布局.attr('visibility', 'visible')
    if (!result) ui.关注率_布局.attr('visibility', 'invisible')
})

// ui.收藏.on('check', (result) => {
//     if (result) ui.收藏率_布局.attr('visibility', 'visible')
//     if (!result) ui.收藏率_布局.attr('visibility', 'invisible')
// })
var pz_看视频 = {
    '点赞': ui.点赞.checked,
    '点赞率': parseInt(ui.点赞率.text()), //  30%
    '关注': ui.关注.checked,
    '关注率': parseInt(ui.关注率.text()), //  60%
    // '收藏': ui.收藏.checked,
    // '收藏率': parseInt(ui.收藏率.text()), //  60%
    '视频时长_min': parseInt(ui.视频时长_min.text()),   //  秒
    '视频时长_max': parseInt(ui.视频时长_max.text()),    //  秒
    '运行数量_视频': parseInt(ui.运行数量_视频.text())
}
var st_pz_看视频 = storages.create('ksp')

try {
    let pz = JSON.parse(st_pz_看视频.get('v'))
    ui.点赞.attr('checked', pz.点赞)
    ui.点赞率.attr('text', pz.点赞率)
    ui.关注.attr('checked', pz.关注)
    ui.关注率.attr('text', pz.关注率)
    // ui.收藏.attr('checked', pz.收藏)
    // ui.收藏率.attr('text', pz.收藏率)

    ui.视频时长_min.attr('text', pz.视频时长_min)
    ui.视频时长_max.attr('text', pz.视频时长_max)
    ui.运行数量_视频.attr('text', pz.运行数量_视频)
} catch (error) {

}

var 显示悬浮窗 = false
ui["start"].on("click", function () {
    st_pz_看视频.put('v', JSON.stringify({
        '点赞': ui.点赞.checked,
        '点赞率': parseInt(ui.点赞率.text()), //  30%
        '关注': ui.关注.checked,
        '关注率': parseInt(ui.关注率.text()), //  60%
        // '收藏': ui.收藏.checked,
        // '收藏率': parseInt(ui.收藏率.text()), //  60%
        '视频时长_min': parseInt(ui.视频时长_min.text()),   //  秒
        '视频时长_max': parseInt(ui.视频时长_max.text()),    //  秒
        '运行数量_视频': parseInt(ui.运行数量_视频.text())
    }))
    if (auto.service == null) {
        toastLog("请开始无障碍服务")
        return
    }
    if (!$floaty.checkPermission()) {
        toastLog("请开始悬浮窗权限...")
        return
    }
    if (显示悬浮窗) {
        alert('你已开启悬浮窗了，无需重复启动')
        return
    }
    threads.start(function () {
        //保存设置
        悬浮窗 = floaty.rawWindow(
            <frame gravity="center">
                <vertical w='auto' gravity="center" >
                    <button id="tcrj" marginTop="30">退出软件</button>
                    <button id="kaishiyunxing" style='Widget.AppCompat.Button.Colored'>开始运行</button>
                </vertical>
            </frame>
        );
        悬浮窗.tcrj.click(function () {
            exit()
        })
        悬浮窗.setPosition(0, device.height / 2);
        显示悬浮窗 = true
        悬浮窗.kaishiyunxing.click(function () {
            if (悬浮窗.kaishiyunxing.text() == "开始运行") {
                // if (!exists_element('推荐', 'text')) {
                //     alert('请在视频首页启动...')
                //     return
                // }
                toastLog('开始运行...')
                悬浮窗.kaishiyunxing.setText("停止运行")
                threads.start(function () {
                    刷视频()
                })
            } else {
                悬浮窗.kaishiyunxing.setText("开始运行")
                toastLog('停止运行')
                threads.shutDownAll()
            }
        })
    })
})

/**
 *  自动刷视频
 */
var Width = device.width
var Height = device.height

function 刷视频() {
    console.hide()
    sleep(350)
    console.show()
    pz_看视频 = {
        '点赞': ui.点赞.checked,
        '点赞率': parseInt(ui.点赞率.text()), //  30%
        '关注': ui.关注.checked,
        '关注率': parseInt(ui.关注率.text()), //  60%
        // '收藏': ui.收藏.checked,
        // '收藏率': parseInt(ui.收藏率.text()), //  60%
        '视频时长_min': parseInt(ui.视频时长_min.text()),   //  秒
        '视频时长_max': parseInt(ui.视频时长_max.text()),    //  秒
        '运行数量': parseInt(ui.运行数量_视频.text())
    }
    var 计数器 = 0

    while (true) {
        sleep(500)
        // if (!exists_element('推荐', 'text')) continue
        toastLog('滑动视频...')
        swipe(parseInt(Width / 2), parseInt(Height / 6) * 5, parseInt(Width / 2), 5, 1500)
        sleep(1500)
        let stayTime = random(pz_看视频.视频时长_min, pz_看视频.视频时长_max)
        toastLog('观看视频：' + stayTime + '秒')
        sleep(stayTime * 1000)
        if (exists_element('忽略提醒', 'text')) click_element(text('忽略提醒').visibleToUser().findOnce())
        //  点赞
        if (pz_看视频.点赞 && pz_看视频.点赞率 > random(1, 100)) {
            toastLog('执行点赞...')
            click_element(descStartsWith('未点赞').visibleToUser().findOne(1500))
            sleep(1500)
        }
        //  关注
        if (pz_看视频.关注 && pz_看视频.关注率 > random(1, 100)) {
            toastLog('执行关注...')
            click_element(desc('关注').visibleToUser().clickable(true).findOne(1500))
            sleep(1500)
        }
        //  收藏
        // if (pz_看视频.收藏 && pz_看视频.收藏率 > random(1, 100)) {
        //     toastLog('执行收藏...')
        //     click_element(descStartsWith('未选中，收藏').visibleToUser().findOne(1500))
        //     sleep(1500)
        // }
        console.info('看视频数量：' + 计数器++)
        console.log('=========');
        if (计数器 >= pz_看视频.运行数量) {
            threads.shutDownAll()
            alert('停止运行，已运行数量：' + pz_看视频.运行数量 + '个')
            return
        }
    }
}

function click_element(element) {
    if (element) click(element.bounds().centerX(), element.bounds().centerY())
}
function exists_element(params, type) {
    if (type == 'id') return id(params).visibleToUser().exists();
    if (type == 'desc') return desc(params).visibleToUser().exists()
    if (type == 'text') return text(params).visibleToUser().exists()
}

